<template>
  <b-container class="mt-5">
    <b-row align-h="center">
      <b-col align="left">
        <label class="label-input" for="input-id">Drone ID:</label>
        <b-form-input id="input-id" v-model="id" @change="listDrones"></b-form-input>
      </b-col>
      <b-col cols="12" md="4" align="left">
        <label class="label-input" for="input-name">Name:</label>
        <b-form-input id="input-name" v-model="name"></b-form-input>
      </b-col>
      <b-col align="left">
        <label class="label-input" for="select-drone">Current Fly:</label>
        <b-form-select
          id="select-fly"
          v-model="selectFly"
          :options="flyOptions"
        ></b-form-select>
      </b-col>
      <b-col align="left">
        <label class="label-input" for="select-drone">Status</label>
        <b-form-select
          id="select-status"
          v-model="status"
          :options="statusOptions"
          @change="listDrones"
        ></b-form-select>
      </b-col>
    </b-row>

    <b-row align-h="center">
      <b-col>
        <div v-if="items" class="col mt-5 mb-5">
          <b-table
            id="my-table"
            :items="filterItems"
            :fields="fields"
            :sort-by.sync="sort"
            :sort-desc.sync="order"
            :per-page="perPage"
            :total-rows="rows"
            thead-class="head-text"
            tbody-tr-class="tr-row"
            responsive="sm"
            borderless
            @row-clicked="myRowClickHandler"
          >

            <template #cell(id)="data">
              <b-col class="mt-4">
                <b class="text-blue"> {{ data.value }} </b>
              </b-col>
            </template>

            <template #cell(name)="data">
              <b-media>
                <template #aside>
                  <b-img
                    :src="data.item.image"
                    width="50"
                    alt="placeholder"
                    rounded="circle"
                  ></b-img>
                </template>
                <div></div>
                <h5 class="mt-2 mb-0 text-left">{{ data.value }}</h5>
                <p class="mb-0 text-left address-subtitle">
                  {{ data.item.address }}
                </p>
              </b-media>
            </template>

            <template #cell(battery)="data">
              <ProgressPercent :value="data.value"></ProgressPercent>
            </template>

            <template #cell(max_speed)="data">
              <b-col class="mt-4">
                <b class="text-blue">
                  {{ data.value }}<span class="miles">m/h</span>
                </b>
              </b-col>
            </template>

            <template #cell(average_speed)="data">
              <b-col class="mt-4">
                <b class="text-blue">
                  {{ data.value }}<span class="miles">m/h</span>
                </b>
              </b-col>
            </template>

            <template #cell(fly)="data">
              <LineFly
                :value="data.item.fly"
                :status="data.item.status"
              ></LineFly>
            </template>

            <template #cell(status)="data">
              <b-button
                size="sm"
                :disabled="['success', 'offline'].includes(data.item.status)"
                :variant="getColor(data.item.status)"
                >{{ data.item.status }}</b-button
              >
            </template>
          </b-table>
        </div>
        <div v-else class="col mt-5 mb-5">
          <h1>Nenhum drone encontrado</h1>
        </div>
      </b-col>
    </b-row>

    <div class="d-flex justify-content-center">
      <div class="d-flex d-inline-block">
        <b-pagination
          v-model="page"
          :total-rows="rows"
          :per-page="1"
          first-number
          last-number
        ></b-pagination>
        <b-form-select class="ml-3" v-model="perPage" :options="limits" @change="listDrones()"></b-form-select>
      </div>
    </div>

  </b-container>
</template>

<script lang="ts">
import Vue from "vue";

import { Drone } from "@/interfaces/drone.interface"

import { SET_DRONE } from '@/store/drone'

import DroneService from "@/services/drone"
import ProgressPercent from "./ProgresPercent.vue";
import LineFly from "./LineFly.vue";

export default Vue.extend({
  name: "HelloWorld",
  components: {
    ProgressPercent,
    LineFly,
  },
  async mounted() {
    await this.countDrones()
    await this.listDrones()
  },
  watch: {
    async order() {
      await this.listDrones()
    },
    async page() {
      await this.listDrones()
    },
  },
  data() {
    return {
      selectFly: null,
      status: null,
      id: '',
      name: '',
      perPage: 5,
      sort: 'id',
      order: false,
      page: 1,
      rows: 100,
      limits: [5, 10, 20, 30],

      flyOptions: [
        { value: null, text: "ALL"},
        { value: "going", text: "GOING" },
        { value: "coming", text: "COMING" },
      ],

      statusOptions: [
        { value: null, text: "ALL"},
        { value: "flying", text: "FLYING" },
        { value: "success", text: "SUCCESS" },
        { value: "delayed", text: "DELAYED" },
        { value: "failed", text: "FAILED" },
        { value: "offline", text: "OFFLINE" },
      ],

      fields: [
        { key: "id", label: "Drone", sortable: true },
        { key: "name", label: "Customer", sortable: true },
        { key: "battery", label: "Batteries", sortable: true },
        { key: "max_speed", sortable: false },
        { key: "average_speed", sortable: false },
        { key: "fly", label: "Crrent Fly", sortable: false },
        { key: "status", sortable: false },
      ],
      items: [] as Drone[],
    };
  },
  computed: {
    filterItems(): Drone[] {
      let filtered = this.items

      if (this.name.length > 0) {
        filtered = filtered.filter(i => {
          return i["name"].toLowerCase().includes(this.name)
        })
      }

      if(this.selectFly) {
        if (this.selectFly == 'going') {
          filtered = filtered.filter(i => {
            return i.fly <= 50
          })
        } else {
          filtered = filtered.filter(i => {
            return i.fly >= 51
          })
        }        
      }

      if (this.status) {
        filtered = filtered.filter(i => {
          return i.status == this.status
        })
      }

      // return filtered.slice(
      //   (this.page - 1) * this.perPage,
      //   this.page * this.perPage,
      // );

      return filtered
    }
  },
  methods: {
    myRowClickHandler(record: any) {
      this.$store.dispatch(SET_DRONE, record)
      this.$router.push(`about/${record.id}`)
    },
    async countDrones() {
      try {
        const total = await DroneService.count()
        this.rows = Math.floor(total / this.perPage)
      } catch (error) {
        
      }
    },
    async listDrones() {
      try {
        const { data } = await DroneService.list(this.page, this.perPage, this.id, this.sort, this.order)
        this.items = data
      } catch (error) {
        alert(error.message)
      }
    },
    getColor(status: string) {
      switch (status) {
        case "failed":
          return "danger";
        case "delayed":
          return "warning";
        default:
          return "primary";
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style>
.tr-row {
  border-bottom: solid 1px #59a9ff;
}

.tr-row:hover {
  cursor: pointer;
  background-color: #59a9ff30;
}

input,
select {
  background-color: #59a9ff2e !important;
  border: solid 1px #59a9ff !important;
  border-radius: 8px !important;
}

.btn-fail {
  background-color: #2797f8 !important;
}

.head-text {
  color: #2a95f3;
  font-size: 12px;
}
.text-blue {
  color: #2a95f3;
}
.miles {
  font-size: 10px;
}
.label-input {
  color: #2a95f3;
  font-weight: 800;
}
.form-control {
  color: #495057;
  background-color: #f3f8fe;
  border-color: #80bdff;
}
.form-control:focus {
  color: #495057;
  background-color: #f3f8fe;
  border-color: #80bdff;
  outline: 0;
  box-shadow: 0 0 0 0.2rem rgba(0, 123, 255, 0.25);
}
.custom-select {
  color: #495057;
  background-color: #f3f8fe;
  border-color: #80bdff;
}
h5 {
  color: #2a95f3;
  font-weight: bold;
}
.address-subtitle {
  color: #2a95f3;
  font-weight: 600;
  font-size: 0.8rem;
}
</style>
